import { QueryParamConfig } from 'serialize-query-params';
export interface ExpectedQueryParam {
    name: string;
    type: QueryParamConfig<any, any>;
    value: any;
}
declare type EncodedValue = string | string[] | null;
export declare const validateArguments: ({ name, type, locationSearch, encodedReceivedValue }: Pick<ExpectedQueryParam, "name" | "type"> & {
    locationSearch: Location['search'];
    encodedReceivedValue: EncodedValue;
}) => void;
export declare const encodeValues: ({ type, name, value, locationSearch }: ExpectedQueryParam & {
    locationSearch: Location['search'];
}) => {
    encodedExpectedValue: string | (string | null)[] | null | undefined;
    encodedReceivedValue: EncodedValue;
    decodedReceivedValue: any;
};
export declare const validateValues: ({ name, value, encodedExpectedValue, encodedReceivedValue, decodedReceivedValue }: Pick<ExpectedQueryParam, 'name' | 'value'> & ReturnType<typeof encodeValues>) => never;
export {};
