'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var react = require('@testing-library/react');
var reactRouterDom = require('react-router-dom');
var serializeQueryParams = require('serialize-query-params');

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

/**
 * Render a given component in a Router for un-browser environments
 */

var renderInRouter = function renderInRouter(Component, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$initialEntries = _ref.initialEntries,
      initialEntries = _ref$initialEntries === void 0 ? ['/'] : _ref$initialEntries,
      renderOptions = _ref.renderOptions,
      _ref$shouldCheckHisto = _ref.shouldCheckHistory,
      shouldCheckHistory = _ref$shouldCheckHisto === void 0 ? false : _ref$shouldCheckHisto;

  var history;
  var renderPayload = react.render(React.createElement(reactRouterDom.MemoryRouter, {
    initialEntries: initialEntries
  }, React.createElement(Component, null), shouldCheckHistory && React.createElement(reactRouterDom.Route, {
    path: '*',
    render: function render(_ref2) {
      var renderedHistory = _ref2.history;
      history = shouldCheckHistory ? renderedHistory : undefined;
      return null;
    }
  })), renderOptions);
  return _extends({}, renderPayload, {
    history: history
  });
};

var ParamTypes = {
  DateParam: serializeQueryParams.DateParam,
  JsonParam: serializeQueryParams.JsonParam,
  ArrayParam: serializeQueryParams.ArrayParam,
  ObjectParam: serializeQueryParams.ObjectParam,
  NumberParam: serializeQueryParams.NumberParam,
  StringParam: serializeQueryParams.StringParam,
  BooleanParam: serializeQueryParams.BooleanParam,
  DateTimeParam: serializeQueryParams.DateTimeParam,
  NumericObjectParam: serializeQueryParams.NumericObjectParam,
  DelimitedArrayParam: serializeQueryParams.DelimitedArrayParam,
  DelimitedNumericArrayParam: serializeQueryParams.DelimitedNumericArrayParam
};

exports.ParamTypes = ParamTypes;
exports.renderInRouter = renderInRouter;
//# sourceMappingURL=react-router-testing-utils.cjs.development.js.map
