import React from 'react';
import { render } from '@testing-library/react';
import { MemoryRouter, Route } from 'react-router-dom';
import { DateParam, JsonParam, ArrayParam, ObjectParam, NumberParam, StringParam, BooleanParam, DateTimeParam, NumericObjectParam, DelimitedArrayParam, DelimitedNumericArrayParam } from 'serialize-query-params';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

/**
 * Render a given component in a Router for un-browser environments
 */

var renderInRouter = function renderInRouter(Component, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$initialEntries = _ref.initialEntries,
      initialEntries = _ref$initialEntries === void 0 ? ['/'] : _ref$initialEntries,
      renderOptions = _ref.renderOptions,
      _ref$shouldCheckHisto = _ref.shouldCheckHistory,
      shouldCheckHistory = _ref$shouldCheckHisto === void 0 ? false : _ref$shouldCheckHisto;

  var history;
  var renderPayload = render(React.createElement(MemoryRouter, {
    initialEntries: initialEntries
  }, React.createElement(Component, null), shouldCheckHistory && React.createElement(Route, {
    path: '*',
    render: function render(_ref2) {
      var renderedHistory = _ref2.history;
      history = shouldCheckHistory ? renderedHistory : undefined;
      return null;
    }
  })), renderOptions);
  return _extends({}, renderPayload, {
    history: history
  });
};

var ParamTypes = {
  DateParam: DateParam,
  JsonParam: JsonParam,
  ArrayParam: ArrayParam,
  ObjectParam: ObjectParam,
  NumberParam: NumberParam,
  StringParam: StringParam,
  BooleanParam: BooleanParam,
  DateTimeParam: DateTimeParam,
  NumericObjectParam: NumericObjectParam,
  DelimitedArrayParam: DelimitedArrayParam,
  DelimitedNumericArrayParam: DelimitedNumericArrayParam
};

export { ParamTypes, renderInRouter };
//# sourceMappingURL=react-router-testing-utils.esm.js.map
